Page MenuHomePhabricator

Add the Packagist webhook to wikimedia/mediawiki repo on GitHub
Closed, DeclinedPublic

Description

Problem
It appears that Packagist has not been updated for mediawiki/core and the site reports that the package is Abandoned.

dev-master hasn't been updated since 2018-04-18 02:14 UTC

Solution
Could someone with access to Packagist and GitHub add the hook as described?

Workaround
Add the mediawiki repository to your composer.json by executing:

composer config repositories.mediawiki vcs https://github.com/wikimedia/mediawiki

This will clone the repo and analyze all of the branches and tags and build the metadata based on that (effectively the same thing packagist is doing).

Event Timeline

It's there, but marked as inactive...

Installing MW via composer isn't actually supported, so is this actually something we want to do/enable? And if not, we should remove/mark MW as deprecated/similar in packagist itself.

Yeah, I'm not sure why this was enabled (happened in 2015 it seems). It was auto-published until 1.29.x as well, but no tags after that, except for dev-master (which stopped working in April).

I've disabled the hook for now.

I would like it enabled because I'm working on building a MediaWiki wrapper that would allow MediaWiki to be installed with Composer. Here's the code so far:
https://github.com/davidbarratt/mediawiki

Basically, at the end, you should be able to do:

composer create-project mediawiki/mediawiki

and the created project, will install mediawiki/core. See T166956

As a workaround, I'm directly adding the repository:
https://github.com/davidbarratt/mediawiki/blob/99c8d329d162277f0addfebd5b8fc725c3352de7/composer.json#L11-L16

That probably comes from a time we thought about using composer to distribute mediawiki and its extensions/skins. However that has eventually been dismissed in favor of the extension registration system and the extension distributor.

Ref:

Vvjjkkii renamed this task from Add the Packagist webhook to wikimedia/mediawiki repo on GitHub to 1tcaaaaaaa.Jul 1 2018, 1:10 AM
Vvjjkkii triaged this task as High priority.
Vvjjkkii updated the task description. (Show Details)
Vvjjkkii removed a subscriber: Aklapper.
CommunityTechBot renamed this task from 1tcaaaaaaa to Add the Packagist webhook to wikimedia/mediawiki repo on GitHub.Jul 2 2018, 4:05 PM
CommunityTechBot raised the priority of this task from High to Needs Triage.
CommunityTechBot updated the task description. (Show Details)
CommunityTechBot added a subscriber: Aklapper.

Is this still a problem?

https://packagist.org/packages/mediawiki/core

says

This package is abandoned and no longer maintained. No replacement package was suggested.

but MediaWiki 1.34.0 seems to be available without issues...?

Is this still a problem?

I believe Packagist will occasionally scan the git repo for updates. Adding the hook will update Packagist almost immediately. I'm not sure why someone with access marked it as abandoned.

Is this still a problem?

I believe Packagist will occasionally scan the git repo for updates. Adding the hook will update Packagist almost immediately. I'm not sure why someone with access marked it as abandoned.

Probably because it's not supported

That probably comes from a time we thought about using composer to distribute mediawiki and its extensions/skins. However that has eventually been dismissed in favor of the extension registration system and the extension distributor.

Ref:

Probably because it's not supported

I think it might be more helpful to add that to the description field in composer.json and let people use it at their own risk.

Probably because it's not supported

I think it might be more helpful to add that to the description field in composer.json and let people use it at their own risk.

It doesn't work like that though. We end up with support requests... "Why can't I install X extension via composer, but I can Y?" etc

Krinkle closed this task as Declined.EditedMar 8 2020, 4:16 PM

There are a many of ways in which one could distribute, install, support or extend the MediaWiki software. A number of those we have embraced officially. Which means we committed to understanding the strenghts (and weaknesses) of those methods, and do our best to make sure that we way we build stuff in core optimises for that and for a good developer experience when using those methods.

Just because there are other ways in which it could be distributed, doesn't mean we should. If there are specific high-level use cases that are currently hard or difficult, I recommend starting conversations about those and welcoming other ways to fulfil those. If those are easy to satisfy and/or important to the movement, then it's possible those might get accepted, possibly in the short-term, or at a later time when we can commit to doing it well and in a sustainable manner.

Third parties are welcome to distribute the software on their own in a way that is compatible with our licensing terms with any other package manners at their own risk, knowing that the core software will likely not take on additional maintenance costs or compromise other distributions to address issues unique to it.

This task as currently written is a very specific request to tune a particular aspect of a larger initiative of to distribute MediaWIki via Packagist.org. This is a direction we have explicitly moved away from in the past, and per the above, would take considerable effort to invest in properly. This task is not the venue to discuss that investment. Feel free re-open if and when such decision is made.

Given mediawiki/core on packagist.org is an artifact from a past experiment and that we do not support that method at all: shouldn't we delete the package from packagist.org?